def calculate_pitch(snd_part):
    pitch = snd_part.to_pitch(time_step=TIME_STEP,
                              pitch_floor=200, pitch_ceiling=800)
    pitch_track = pitch.selected_array
    pitch_track = pitch_track[pitch_track['frequency'] != 0]

    if len(pitch_track) == 0:
        return np.nan, np.nan, np.nan
    else:
        median_pitch = np.nanmedian(pitch_track['frequency'])
        median_pitch_i = np.argmin(abs(pitch_track['frequency'] - median_pitch))
        median_pitch_strength = pitch_track['strength'][median_pitch_i]
        pitch_iqr = scipy.stats.iqr(pitch_track['frequency'])
        assert median_pitch >= 200 or np.isnan(median_pitch)
        return median_pitch, median_pitch_strength, pitch_iqr
