LEARNED = 'LEARNED'
RANDOM = 'RANDOM'
N = 5

memory = joblib.Memory('cache/')


def get_audio_fn(i, what):
    if what == LEARNED:
        return f'data/final_speech_{i+1}.wav'
    elif what == RANDOM:
        return f'data/final_speech_random{i+1}.wav'
    raise ValueError(what)


def get_times():
    return [0.45 + i * 6.41 + j * 0.6 for i in range(200) for j in range(10)]


@memory.cache
def get_formants(i, what):
    fn = get_audio_fn(i, what)
    formant = parselmouth.Sound(fn).to_formant_burg()
    times = get_times()
    return [tuple(formant.get_value_at_time(f, t) for f in (1, 2)) for t in times]


for what in [LEARNED, RANDOM]:
    for i in range(N):
        formants = get_formants(i, what)
        F1, F2 = list(map(list, zip(*formants)))
        hull = scipy.spatial.ConvexHull(formants)
        print(what, i, hull.area)
